# Class ReadEnds

java.lang.Object
picard.sam.util.PhysicalLocationInt
picard.sam.markduplicates.util.ReadEnds

All Implemented Interfaces:
  `Serializable, PhysicalLocation`

Direct Known Subclasses:
  `ReadEndsForMarkDuplicates, ReadEndsForMateCigar`

public abstract class ReadEnds extends PhysicalLocationInt
Little struct-like class to hold read pair (and fragment) end data for duplicate marking.

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final byte`
`F`
`static final byte`
`FF`
`static final byte`
`FR`
`boolean`
`isOpticalDuplicate`
A *transient* flag marking this read end as being an optical duplicate.
`short`
`libraryId`
`byte`
`orientation`
`byte`
`orientationForOpticalDuplicates`
For optical duplicate detection the orientation matters regard to 1st or 2nd end of a mate
`static final byte`
`R`
`int`
`read1Coordinate`
`int`
`read1ReferenceIndex`
`int`
`read2Coordinate`
`int`
`read2ReferenceIndex`
`short`
`readGroup`
`static final byte`
`RF`
`static final byte`
`RR`

### Fields inherited from class PhysicalLocationInt

`tile, x, y`

### Fields inherited from interface PhysicalLocation

`NO_VALUE`

## Constructor Summary

Constructors
Constructor
Description
`ReadEnds()`

## Method Summary

Modifier and Type
Method
Description
`short`
`getLibraryId()`
`static byte`
`getOrientationByte(boolean read1NegativeStrand, boolean read2NegativeStrand)`
Returns a single byte that encodes the orientation of the two reads in a pair.
`short`
`getReadGroup()`
`boolean`
`isPaired()`
`void`
`setLibraryId(short libraryId)`
`void`
`setReadGroup(short readGroup)`

### Methods inherited from class PhysicalLocationInt

`getTile, getX, getY, setTile, setX, setY`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface PhysicalLocation

`hasLocation`

## Field Details

### F

public static final byte F

See Also:
  - Constant Field Values

### R

public static final byte R

See Also:
  - Constant Field Values

### FF

public static final byte FF

See Also:
  - Constant Field Values

### FR

public static final byte FR

See Also:
  - Constant Field Values

### RR

public static final byte RR

See Also:
  - Constant Field Values

### RF

public static final byte RF

See Also:
  - Constant Field Values

### libraryId

public short libraryId

### orientation

public byte orientation

### read1ReferenceIndex

public int read1ReferenceIndex

### read1Coordinate

public int read1Coordinate

### read2ReferenceIndex

public int read2ReferenceIndex

### read2Coordinate

public int read2Coordinate

### readGroup

public short readGroup

### orientationForOpticalDuplicates

public byte orientationForOpticalDuplicates
For optical duplicate detection the orientation matters regard to 1st or 2nd end of a mate

### isOpticalDuplicate

public transient boolean isOpticalDuplicate
A *transient* flag marking this read end as being an optical duplicate.

## Constructor Details

### ReadEnds

public ReadEnds()

## Method Details

### isPaired

public boolean isPaired()

### getReadGroup

public short getReadGroup()

Specified by:
  `getReadGroup` in interface `PhysicalLocation`
Overrides:
  `getReadGroup` in class `PhysicalLocationInt`

### setReadGroup

public void setReadGroup(short readGroup)

Specified by:
  `setReadGroup` in interface `PhysicalLocation`
Overrides:
  `setReadGroup` in class `PhysicalLocationInt`

### getLibraryId

public short getLibraryId()

Specified by:
  `getLibraryId` in interface `PhysicalLocation`
Overrides:
  `getLibraryId` in class `PhysicalLocationInt`

### setLibraryId

public void setLibraryId(short libraryId)

Specified by:
  `setLibraryId` in interface `PhysicalLocation`
Overrides:
  `setLibraryId` in class `PhysicalLocationInt`

### getOrientationByte

public static byte getOrientationByte(boolean read1NegativeStrand, boolean read2NegativeStrand)
Returns a single byte that encodes the orientation of the two reads in a pair.